// I2C Scanner
// Written by Nick Gammon
// Date: 20th April 2011
// I2C on A5-SCL and A4-SDA
// Added an SSD1306 OLED display by PA0RWE 02-04-2016

#include <Wire.h>
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET   5

Adafruit_SSD1306 display(OLED_RESET);

void setup() {
  Serial.begin (115200);
  Wire.begin();
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3C (for the 128x64)

  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);

  // Leonardo: wait for serial port to connect
  while (!Serial) 
    {
    }

  Serial.println ();
  Serial.println ("I2C scanner. Scanning ...");

  byte count = 1;
  byte pos = 5;
  
  display.setCursor(5,pos);
//  Wire.begin();
  
  for (byte i = 8; i < 120; i++)
  {
    Wire.beginTransmission (i);
    if (Wire.endTransmission () == 0)
      {
      Serial.print ("Found address: ");
      Serial.print (i, DEC);
      Serial.print (" (0x");
      Serial.print (i, HEX);
      Serial.println (")");


      if (count == 1) display.println("Found address: ");
      display.setCursor(5, pos+count*12);
      display.print (i, DEC);
      display.print (" (0x");
      display.print (i, HEX);
      display.print (")");      
      if (i == 60) display.println("  OLED");
      if (i == 111 | i == 96) display.println("  Si5351");
      if (i == 85)  display.println("  Si570");
      display.display();
      
      count++;
      delay (1);  // maybe unneeded?
      } // end of good response
  } // end of for loop
  
  Serial.println ("Done.");
  Serial.print ("Found ");
  Serial.print (count, DEC);
  Serial.println (" device(s).");
}  // end of setup

void loop() {}
